<?php
declare(strict_types=1);

namespace App\Doctrine\Education;

use App\Doctrine\AbstractExtension;
use App\Entity\Access\Access;
use App\Entity\Education\EducationNotationConfig;
use Doctrine\ORM\QueryBuilder;
use Symfony\Bundle\SecurityBundle\Security;

/**
 * Class CurrentEducationNotationConfigExtension : Filtre de sécurité par défaut pour une resource EducationNotationConfig
 * @package App\Doctrine\Core
 */
final class CurrentEducationNotationConfigExtension extends AbstractExtension
{
    public function __construct(private Security $security)
    { }

    protected function addWhere(QueryBuilder $queryBuilder, string $resourceClass): void
    {
        if (EducationNotationConfig::class !== $resourceClass) {
            return;
        }

        /** @var Access $currentUser */
        $currentUser = $this->security->getUser();
        $rootAlias = $queryBuilder->getRootAliases()[0];
        $queryBuilder
            ->andWhere(sprintf('%s.organization = :organization', $rootAlias))
            ->setParameter('organization', $currentUser->getOrganization())
        ;
    }
}